#ifndef BIRRERIA_H
#define BIRRERIA_H

#include <JTC/JTC.h>

using namespace std;

#define OR 20
#define B 40

class Birreria : public JTCMonitor {

private:
    int in;
    int out;
    int n_ordini;
    int BO[OR];
    int BB;
    
    bool ancoraDaServire ( int& quantita ) {
        int disponibilita = B - BB;
        if ( disponibilita >= quantita ) {
            disponibilita -= quantita;
            quantita = 0;
            BB = B - disponibilita;
        }
        else {
            quantita -= disponibilita;
            disponibilita = 0;
            BB = B;
        }
        return quantita > 0;
    }
    
public:
    Birreria () {
        in = 0;
        out = 0;
        n_ordini = 0;
        for ( int i = 0; i < OR; i++ )
			BO[i] = 0;
		BB = B;
    }
    void putOrdine ( int quantita ) {
        JTCSynchronized sync ( *this );
        while ( n_ordini == OR )
			wait ();
		n_ordini++;
        BO[in] = quantita;
		in = (in + 1) % OR;
		notifyAll ();
    }
    int getOrdine() {
        JTCSynchronized sync ( *this );
        while ( n_ordini == 0 ) 
			wait ();
		n_ordini--; 
		int quantita = BO[out];
		out = ( out + 1 ) % OR;
		notifyAll ();
		return quantita;
    }
    void putBirra () {
        JTCSynchronized sync ( *this );
        while ( BB == 0 ) // bancone delle birre pieno
            wait ();
        BB--;
        notifyAll();
    }
    void getBirre ( int quantita ) {
        JTCSynchronized sync ( *this );
        while ( ancoraDaServire ( quantita ) ) 
            wait();
        notifyAll ();
    }
};

#endif
