#!/usr/bin/perl

open(FILE,$ARGV[0]) || die("impossibile aprire il file ...\n");

open(GOOD,">goodseq.txt");
open(BAD,">badseq.txt");

#
# La prima lettura viene effettuata a parte.
#
$_ = <FILE>;

while ( $_ ) {
    
    #
    # Appena trovo una riga nel formato >N,M
    # Apro un while interno che verifica che subito dopo ci siano N numeri divisibili per M
    #
    
    if ( /^>([0-9]+),([0-9]+)/ ) {

        $N = $1;
        $M = $2;
        
        #
        # @sequenza viene azzerato. A fine while interno conterr la sequenza di numeri, incluso
        # il '>N,M' iniziale.
        #
        
        @sequenza = ();
        push(@sequenza,$_);
        $divisibili = 1;

        #
        # Il while va avanti fintantoch il file non finisce oppure non si incontra una nuova linea del tipo >N,M
        #
        # Notare il raggruppamento di parentesi.
        # A causa della precedenza tra operatori, l'espressione $_ = <FILE> && $_ !~ /^>/
        # Sarebbe equivalente a $_ = ( <FILE> && ($_ !~ /^>/) ) 
        #

        while ( ($_ = <FILE>) && ($_ !~ /^>/) ) {
            push(@sequenza,$_);
            if ( $_ % $M != 0 ) {
                $divisibili = 0;
            }
        }
        
        # Cambia $". Questa variabile normalmente vale ' ', e rappresenta il carattere usato
        # per interpolare le stampe di array
        # Ad esempio se $" = '*' e @ciccio = ( 'mele', 'pere', 'arance' ) il comando print "@ciccio"
        # Stampa in output: mele*pere*arance
        #
        # Nel nostro caso, ogni elemento di sequenza contiene come ultimo carattere uno '\n'
        # con $" impostato a ' ', e @ciccio = ( "mele\n", "pere\n", "arance\n" ), avremmo in output
        # di print "@ciccio":
        #
        # mele
        #  pere
        #  arance
        #
        # (si noti la strana indentazione dovuta alla combinazione di \n con " " usato come separatore) 
        
        $" = ""; 
        
        #
        # Se la sequenza  corretta (ho contato esattamente $N numeri e quindi @sequenza deve contenere $N+1 elementi, poich
        # contiene anche la riga ">N,M", e nessuno dei numeri non era multiplo di $M)
        # allora questa va in GOOD, altrimenti in BAD.
        #
        
        if ( $N == $#sequenza && $divisibili == 1 ) {
            print GOOD "@sequenza";
        }
        else {
            print BAD "@sequenza";
        }
    } # fine IF interno
} # fine WHILE esterno

close(GOOD);
close(BAD);
